program quicksort;
uses crt,dos;
type mas = array [1..500] of integer;
var Key : mas;
    i,k,intrv,pirmas,paskutinis,lygsk,sk : integer;
    Rez : array [1..20] of record                         //irasu masyvas rezultatams issaugoti
                MasRyb,LygSkaic: integer;
                Laikas,VLygLaik,TLygSk,LygSkirt: real;
                end;
    hh,mm,fs,fms,es,ems : integer;                       //kintamieji skirti laikui uzfiksuoti
    VienasLyg,time : real;
    rezfailas,rusfailas : text;
    fname : string;
//------------------------------------------------------------------------------
function genfname( nr : integer) : string;               //funkcija sugenerojanti failo pavadinima i kuri bus irashyti rusiavimo rezultatai
var sveik,liek : integer;
begin
    if nr<10 then
            genfname:='Rusiavimo failas Nr. '+chr(48+nr)+'.txt'
            else
            begin
               sveik:= nr div 10;
               liek:= nr mod 10;
               genfname:='Rusiavimo failas Nr. '+chr(48+sveik)+chr(48+liek)+'.txt';
            end;
end;
//------------------------------------------------------------------------------
procedure Nuvalyti(last : integer);                        //proc. nuvalanti masyva, priskirama visiems elementams nuli
var i : integer;
begin
    for i:=1 to last do
        Key[i]:=0;
end;
//------------------------------------------------------------------------------
function TeorLygSk(n : integer) : real;                   // funkcija paskaiciojanti lyginimu skaiciu pagal formule Nlog2N
begin
    TeorLygSk:=n*(ln(n)/ln(2));
end;
//------------------------------------------------------------------------------
procedure VLL(LS : integer;Tm : real; var VienLyg : real);   //proc. paskaiciojanti kiek uztrunka vienas lyginimas
begin
    VienLyg:=(Tm/LS)*100;
end;
//------------------------------------------------------------------------------
procedure Uzpildyti(intervalas,last : integer);              //proc. uzpildanti masyva betkokiais skaicias intervale nuo nulio iki skaiciaus nurodyto
var i : integer;                                             //kintamajame "intervalas"
begin
       for i:=1 to last do
    begin
        sk:=random(intervalas);
        Key[i]:=sk;
    end;
end;
//------------------------------------------------------------------------------
procedure PPos(first,last:integer; var PivotPos : integer);
var x1,x2,x3 : integer;
begin                                                       //proc. atrenkanti is skaiciu intervalo 3 ir is ju pasirenka vidutini.
    if first=1 then                                          //Skaiciu parinkimas tuo atveju kai masyvas rusiojamas i kaire nuo dalinimo reiksmes
    begin
    repeat
    x1:=random(last);
    until x1<>0;
    repeat
    x2:=random(last);
    until (x2<>0);
    repeat
    x3:=random(last);
    until (x3<>0);
    end
    else if first>1 then                                //Cia skaiciu parenka tuo atveju kai rusiavimas viksta i desine pusia
     begin
        repeat
        x1:=first+random(last-first);
        until x1<>0;

        repeat
        x2:=first+random(last-first);
        until (x2<>0);

        repeat
        x3:=first+random(last-first);
        until (x3<>0);
end;
      if (Key[x1]<Key[x2]) and (Key[x2]<Key[x3]) then PivotPos:=x2                //Cia is triju parinktu skaiciu ishrenkamas vidutinis kuris tampa dalinimo reiksme rusiuojamoje
    else if (Key[x3]<Key[x2]) and (Key[x2]<Key[x1]) then PivotPos:=x2;            //masyvo dalyje
    if (Key[x2]<Key[x3]) and (Key[x3]<Key[x1]) then PivotPos:=x3
    else if (Key[x1]<Key[x3]) and (Key[x3]<Key[x2]) then PivotPos:=x3;
    if (Key[x3]<Key[x1]) and (Key[x1]<Key[x2]) then PivotPos:=x1
    else if (Key[x2]<Key[x1]) and (Key[x1]<Key[x3]) then PivotPos:=x1;
    if (Key[x1]=Key[x2]) and (Key[x2]=Key[x3]) then PivotPos:=x1;
    if Key[x1]=Key[x2] then PivotPos:=x1 else if Key[x2]=Key[x3] then PivotPos:=x2
    else if Key[x1]=Key[x3] then PivotPos:=x1;
end;
//------------------------------------------------------------------------------
procedure Partition(First,Last,PivotPos : integer; var OutPivotPos : integer);   //Proc. skirta masyvo intervala surusioti dalinimo reiksmes
var ats,i : integer;                                                              //atzvilgiu i kaire mazesni i desne didesni elementai.
begin
    ats:=Key[PivotPos];                 //naudojamas Luammo algoritmas
    Key[PivotPos]:=Key[First];          //dabartine d.r. reiksme sukeiciama su pirmaja
    Key[First]:=ats;
    PivotPos:=First;
    for i:=First+1 to Last do           //prasideda rusiavimo tikrinami visi elementai nuo antro intervalo elemento iki paskutino
        begin
         lygsk:=lygsk+1;
        if Key[i]<Key[First] then       //jei tikrimas elementas yra mazesnis uz d.r tai d.r indeksas padidinamas vienetu
            begin                       // ir tikrinama elementa nusiunciame i padidinta indekso vieta o ten buvusi elementa i "i" vieta
                  PivotPos:=PivotPos+1;
                  ats:=Key[i];
                  Key[i]:=Key[PivotPos];
                  Key[PivotPos]:=ats;
            end;
          end;                             //Po viso intervalo surusiavimo pirma elementa kur randasi d.r nusiunciam i vieta kur rodo d.r
    ats:=Key[First];                       //indeksas "PivotPos", o i pirma vieta ta elementa kuris ten buvo
    Key[First]:=Key[PivotPos];
    Key[PivotPos]:=ats;
    OutPivotPos:=PivotPos;
end;
//------------------------------------------------------------------------------
procedure QSort(First,Last : integer);                                           //Proc. kuri atlieka ciklini intervalu parinkima
var TempPivotPos,PivotPos,k : integer;                                           //kreipdamasi pati i save rekursiskai
begin
if First<Last then
    begin
    PPos(First,Last,TempPivotPos);                  //atrenka d.r ir jos pradine pozicija
    Partition(First,Last,TempPivotPos,PivotPos);    //surusioja intervala d.r atzvilgiu
    QSort(First,PivotPos-1);                        //kreipiasi i save kairiosios puses nuo d.r rusiavimui
    QSort(PivotPos+1,Last);                         //kreipiasi i save desiniosio puses nuo d.r rusiavimui
    end;
end;
//------------------------------------------------------------------------------
begin

for k:=1 to high(Rez) do                                              //Pradedamas ciklas daugkartiniam programos paleidimui
begin
    //fname:=genfname(k);                                            //Sugenerojamas failo pavadinimas i kuriame bus atvaizduotas pradinis masyvas ir surusiotas
    //assign(rusfailas,fname);rewrite(rusfailas);                     //sukuriamas failas
    lygsk:=0;                                                       //sunulinamas lyginimu skaitliukas
    gettime(hh,mm,fs,fms);                                          //fiksojamas pradinis laikas
    pirmas:=low(Key);                                               //nustatome apatini masyvo rezi
    paskutinis:=random(high(Key));                                  //nustatome virsutini masyvo rezi
    intrv:=random(1000);                                            //nustatomas intervalas is kurio bus generuojami bet kokie skaiciai
    writeln('Sugeneruotas masyvas su max :',paskutinis,' Ir inervalu :',intrv);   //irasome informacija i faila
    writeln('----------------------------------------------------------------------');
    Uzpildyti(intrv,paskutinis);                                     //masyvas uzpildomas ivairias skaiciaias
    for i:=1 to paskutinis do                                        //visi elementai irashomi i faila
    begin
        write(Key[i],',');
        if (i mod 20)=0 then writeln();
    end;

    QSort(pirmas,paskutinis);                                       //pradedamas rusiavima
    writeln(' ');
    writeln('----------------------------------------------------------------------');
    for i:=1 to paskutinis do                                      //surusiotas masyva atspauzdinamas faile
    begin
        write(Key[i],',');
        if (i mod 20)=0 then writeln();
    end;
    Nuvalyti(paskutinis);                                          //masyvas nuvalomas
    gettime(hh,mm,es,ems);                                         //fiksojamas galutinis laikas
    es:=abs(es-fs);
    if ems<fms then
    begin
        es:=es-1;
        ems:=100-fms+ems;
    end
    else
         ems:=abs(ems-fms);
    time:=es+(ems/100);                                             //apskaiciojamas rusiavimo laikas
    VLL(lygsk,time,VienasLyg);                                      //apskaiciojama kiek uztruko vienas lyginimas
                                                                    //rezultatai isaugomi irase
    Rez[k].MasRyb:=paskutinis;                                      //masyvo dydis
    Rez[k].LygSkaic:=lygsk;                                         //lyginimu skaicius
    Rez[k].TLygSk:=TeorLygSk(paskutinis);                           //lyginimu skaicius pagal formule
    Rez[k].Laikas:=time;                                            //lyginmu atlikimo laikas
    Rez[k].LygSkirt:=abs(TeorLygSk(paskutinis)-lygsk);              //teorinio ir realaus lyginmu skaiciaus paliginimas
    Rez[k].VLygLaik:=VienasLyg;                                     //vieno lyginimo atlikimo laikas
    //close(rusfailas);
end;
assign(rezfailas,'rez.txt');rewrite(rezfailas);                     //vis rezultatai atspauzdinami lenteleje i rezultatu faila
writeln(rezfailas,'Rus.','Masyvo':7,'Teor.':7,'Lyg.':7,'Lyg.':7,'Atlikimo':14,'Vieno Lyg.':14);
writeln(rezfailas,'Nr.','dydis':6,'Lyg. Sk.':11,'Sk.':5,'Skirtumas':11,'Laikas(ms)':12,'Laikas':9);
for k:=1 to high(Rez) do
    writeln(rezfailas,k:3,Rez[k].MasRyb:5,Rez[k].TLygSk:9:0,Rez[k].LygSkaic:7,Rez[k].LygSkirt:8:0,Rez[k].Laikas:9:2,Rez[k].VLygLaik:14:4);
readln;
close(rezfailas);
end.

